/**
 * @file Scanf.h
 * @author apio (cloudapio.eu)
 * @brief Scanf implementation.
 *
 * @copyright Copyright (c) 2023, the Luna authors.
 *
 */

#pragma once
#include <stdarg.h>

/**
 * @brief scanf() implementation.
 *
 * @param str The string to read input from.
 * @param format The format string.
 * @param ap The variadic argument list.
 * @return int The number of arguments read, or -1 if the string was empty.
 */
int scanf_impl(const char* str, const char* format, va_list ap);
